;Definizioni dei registri usati nel progetto

W_TEMP			equ	0x71		;Registri temporanei per il salvataggio del contesto durante l'esecuzione
STATUS_TEMP		equ	0x72		;dell'interrupt. Le locazioni sono quelle condivise tra tutti i 4 banchi
PCLATH_TEMP		equ	0x73		;in modo da facilitare il context switch
T_REG_TEMP		equ	0x74
FSR_TEMP		equ	0x75

STAPRO			equ 0x76		;Registro di flag del protocollo di comunicazione
BUFLEN			equ	0x77		;Contatore associato alla lunghezza del buffer in memoria
LENPAC			equ	0x78		;Memorizza la lunghezza del pacchetto
BUFREAD			equ	0x79		;Contatore associato al processo del buffer
DML				equ	0x7A		;Memorizza il numero di bytes del dato da leggere/scrivere
DMC				equ	0x7B		;Contatore associato al processo della memoria dati
DATMEM			equ	0x7C		;Memorizza la locazione di partenza dove leggere/scrivere il dato
TEMPREG			equ	0x7F		;Registro temporaneo

BITCOUNT		equ	0x30		;Contatore associato alla scrittura dei bit nel buffer (interrupt)
BITWORD			equ	0x31		;Memorizza la profondit del simbolo (da 1 a 5)
FLAGREG			equ	0x32		;Registro di flag di uso generale
UNITA			equ	0x35		;Registri che contengono il valore convertito dei contatori
DECINE			equ	0x36
CENTINAIA		equ	0x37

Bit_Start		equ	0x90		;Locazione della memoria bits del generatore (banco 3)
Data_Start		equ	0x10		;Locazione inziale della memoria dati (banco 2)
Data_End		equ	0x6F		;Locazione finale della memoria dati (banco 2)

cnt_bit			equ 0x110		;reg che uso per contare i bit letti per sapere se ne ho letti 8 -> il byte  pronto 
byteletti		equ 0x111		;reg per sapere quanti byte ho gi letto
bit_uno			equ 0x112		;reg che uso per contare gli 1 che sono nella sequenza letta
byte_biased		equ	0x114		; il vettore dei numeri random biased
byte_unbiased	equ 0x146		; il vettore dei numeri random unbiased
;TODO se l' ultimo byte unbiased non  completo (esempio ottengo 8*15+3 = 15 byte unbiased + 3 bit) cosa  meglio fare? lo invio lo stesso?

Buffer_Location	equ 0xA0		;Locazione iniziale del buffer USART
Buffer_Lenght	equ	0x43		;Lunghezza max del buffer

;TODO: volendo si possono levare dalle locazioni condivise di mem dati i registri che
;l'interrupt non tocca e metterli nel banco 0