;TODO: eventuali errori in realt non sono errori ma Easter eggs o riddle da risolvere
;se invece sono proprio errori sono dovuti alle tante modifiche che ho fatto e che non sono state ripristinate completamente
;Disclaimer: non sono responsabile di eventuali problemi derivante dall' uso di questo programma o dalla lettura del sorgente

	list      p=16f877a
	#include <p16f877a.inc>


;************************************************************************
;*	includo i file con le costanti e macro e le varibili usate nel progetto*
;************************************************************************
	#include <const.inc>
	#include <macro.inc>
	#include <reg.inc>
;************************************************************************
;*																		*
;************************************************************************


Reset_Vector code 0x0
	goto	Start

Interrupt_Vector code 0x0004
	goto	IntVect
	
	code	0x000A

;************************************************************************
;*	INIZIALIZZAZIONE													*
;************************************************************************

Start
	bsf		STATUS,RP0			;Selezione banco 1
	bcf		STATUS,RP1

	movlw	b'00100000'			;Settaggio port B
	movwf	TRISB
	bcf		TRISC,6				;Settaggio port C

	movlw	VELOCITA			;imposto la velocit per la comunicazione seriale
	movwf	SPBRG

	bsf		TXSTA,TXEN			;Abilitazione trasmissione dei dati
	bsf		TXSTA,BRGH			;Selezione high speed baud rate --> BRGH= 1
	
	bsf		INTCON,PEIE			;Abilitazione INT da periferiche
	bsf		PIE1,RCIE			;Abilitazione INT per ricezione USART
	bsf		PIE1,TMR2IE			;Abilitazione INT da Timer2

	movlw	MATCHING			;imposto il valore di matching del timer2
	movwf	PR2

	bcf		STATUS,RP0			;Selezione banco 0
	bcf		STATUS,RP1

	movlw	b'00001000'			;Settaggio a 1:1 del prescaler e 1:2 del postscaler
	movwf	T2CON				;e spegnimento del timer
	clrf	TMR2				;Azzeramento del timer2
	bcf		PIR1,TMR2IF			;Azzeramento flag di interrupt Timer2
	bcf		PIR1,RCIF			;Azzeramento flag di interrupt RCIF (ricezione USART)
	bsf		RCSTA,CREN			;Abilitazione ricezione continua dei dati
	bsf		RCSTA,SPEN			;Abilitazione porta seriale

	call	ClearAll			;Reset completo dei file registers
	call	InitAll				;Inizializzazione di eventuali porzioni di memoria
	
;************************************************************************
;*																		*
;************************************************************************


;************************************************************************
;*	MAIN																*
;************************************************************************

Main
	bsf		INTCON,GIE			;Abilitazione INT globale
TnbExec
	btfsc	FLAGREG,RETCOU
	goto	ReturnCountersExec
	btfsc	FLAGREG,STAACQ
	goto	RunAcqExec
	btfsc	FLAGREG,STOACQ
	goto	StopAcqExec
	btfsc	FLAGREG,RST
	goto	ResetExec
Tnb
	bcf		STAPRO,ERR
	call	WaitNewByte			;Controllo dei flag del protocollo per avviare l'elaborazione dei
	btfss	STAPRO,HEADER		;comandi/dati ricevuti
	goto	Header
	btfss	STAPRO,BYTPAC
	goto	NumByte
	btfss	STAPRO,PARS
	goto	Parser
	goto	ReadStopByte


Header
;************************************************************************

	movf	BUFREAD,w			;Caricamento dell'indirizzo di destinazione nel puntatore FSR
	addlw	Buffer_Location		;(Buffer_Location + BUFREAD)
	movwf	FSR
	movf	INDF,w				;Recupero del byte e scrittura in w
	movwf	TEMPREG				;Salvataggio del byte in un registro tampone

	bcf		STATUS,Z			;Controllo del tipo di header: se comando si salta a HeCo, se dati
	sublw	HEADER_COMM			;si salta a HeDa. Se l'header non  valido viene generato un
	btfsc	STATUS,Z			;errore (HeaderError)
	goto	HeCo
	movf	TEMPREG,w
	bcf		STATUS,Z
	sublw	HEADER_DATO
	btfsc	STATUS,Z
	goto	HeDa
	call	HeaderError
	goto	Tnb
HeCo
	bsf		STAPRO,HEADER		;Settaggio del flag HEADER
	incf	BUFREAD,1			;Incremento di BUFREAD
	btfsc	STAPRO,WDATA		;Test di WDATA e RDATA: se 1 dei 2  settato significa che  stato ricevuto 
	call	CommSeReError		;un comando successivamente ad un precedente comando di scambio dati 
	btfsc	STAPRO,RDATA		;(il protocollo era in attesa dati)
	call	CommSeReError
	goto	Tnb
HeDa
	bsf		STAPRO,HEADER		;Settaggio del flag HEADER
	incf	BUFREAD,1			;Incremento di BUFREAD
	btfsc	STAPRO,WDATA		;Test di WDATA e RDATA: se 1 dei 2  settato significa che  stato ricevuto 
	goto	Jump6				;un dato non successivamente ad un'istruzione di scambio dati
	btfss	STAPRO,RDATA		;(il protocollo era in attesa comandi)
	call	DataSeReError		
Jump6
	goto	Tnb


NumByte
;************************************************************************

	movf	BUFREAD,w			;Caricamento dell'indirizzo di destinazione nel puntatore FSR
	addlw	Buffer_Location		;(Buffer_Location + BUFREAD)
	movwf	FSR
	movf	INDF,w				;Recupero del byte e scrittura in w
	movwf	LENPAC				;Scrittura del numero di bytes del pacchetto nel registro appropriato
	incf	BUFREAD,1
	bsf		STAPRO,BYTPAC		;Settaggio del flag BYTPAC
	btfss	STAPRO,WDATA		;Se la condizione WDATA = 1  verificata, il pacchetto in arrivo 
	goto	Jump4				;un dato. Viene controllato che la lunghezza del dato fornita dal
	movlw	0x03				;comando precedente e la lunghezza del pacchetto siano compatibili
	subwf	LENPAC,w			;((LENPAC-3) = DML), diversamente viene generato un errore
	bcf		STATUS,Z
	subwf	DML,w
	btfsc	STATUS,Z
	goto	Jump4
	call	DataLenMisError
	goto	Tnb
Jump4
	movf	LENPAC,w			;Controllo della condizione LENPAC <= Buffer_Lenght per evitare possibili
	bcf		STATUS,C			;overflow del buffer. Se non  verificata, viene generato un errore
	sublw	Buffer_Lenght
	btfsc	STATUS,C
	goto	Jump5
	call	PacketLenghtError
	goto	Tnb
Jump5
	movlw	0x4					;Controllo della condizione LENPAC >= 3. Se non  verificata, viene
	bcf		STATUS,C			;generato un errore
	subwf	LENPAC,w
	btfss	STATUS,C
	call	PacketLenghtError
	goto	Tnb


Parser
;************************************************************************

ParsWData
	btfss	STAPRO,WDATA		;Test di WDATA, proseguo nell'esecuzione se  1
	goto	ParsRData
	bcf		STAPRO,RDATA		;Serve per StopByteError
Loop2
	movf	DML,w				;Controllo di DMC>=DML (DML=80, DMC va da o a 79): se vera, il ciclo
	bcf		STATUS,C			;ha terminato la scrittura in memoria del dato nel buffer
	subwf	DMC,w				;(settato PARS e resettato WDATA) e avviene il ritorno in attesa del
	btfss	STATUS,C			;byte di stop
	goto	Jump8
	bsf		STAPRO,PARS
	bcf		STAPRO,WDATA
	goto	Tnb
Jump8
	movf	BUFREAD,w			;Caricamento dell'indirizzo di destinazione nel puntatore FSR
	addlw	Buffer_Location		;(Buffer_Location + BUFREAD)
	movwf	FSR
	movf	INDF,w				;Recupero del byte e scrittura in w
	movwf	TEMPREG
	movf	DATMEM,w			;Scrittura del byte nella locazione puntata da DATMEM + DMC,
	addwf	DMC,w				;incremento di DMC e BUFREAD e ritorno a Loop2
	bsf		STATUS,IRP			;Pagine 2,3
	movwf	FSR
	movf	TEMPREG,w
	movwf	INDF
	bcf		STATUS,IRP			;Pagine 0,1
	incf	BUFREAD,1
	incf	DMC,1
	call	WaitNewByte
	goto	Loop2

ParsRData
	btfss	STAPRO,RDATA		;Test di RDATA, l'esecuzione prosegue se  settato
	goto	Command
	movlw	HEADER_DATO			;Invio sulla seriale dell'header dato
	call	TxWait
	movwf	TXREG
	movf	DML,w				;Predisposizione all'invio sulla seriale del numbytes (DML + 3)
	addlw	0x03
	call	TxWait				;Attesa che il byte precedente sia stato inviato
	movwf	TXREG				;Invio effettivo del numbytes
Loop3
	movf	DML,w				;Controllo di DMC>=DML (DML=80, DMC va da o a 79): se vera, il ciclo
	bcf		STATUS,C			;ha terminato la scrittura in memoria del dato nel buffer
	subwf	DMC,w				;(settato PARS e resettato WDATA) e avviene il ritorno in attesa del
	btfss	STATUS,C			;byte di stop
	goto	Jump9
	bsf		STAPRO,PARS
	bcf		STAPRO,RDATA
	goto	WriteStopByte
Jump9
	movf	DATMEM,w			;Caricamento dell'indirizzo sorgente nel puntatore FSR
	addwf	DMC,w				;(Buffer_Location + BUFREAD)
	bsf		STATUS,IRP			;Pagine 2,3
	movwf	FSR
	movf	INDF,w				;Recupero del byte e scrittura in w
	bcf		STATUS,IRP			;Pagine 0,1
	call	TxWait
	movwf	TXREG				;Invio del byte sulla seriale
	incf	DMC,1
	goto	Loop3

Command
	movf	BUFREAD,w			;Caricamento dell'indirizzo sorgente nel puntatore FSR
	addlw	Buffer_Location		;(Buffer_Location + BUFREAD)
	movwf	FSR
	movf	INDF,w				;Recupero del byte e scrittura in w
	movwf	TEMPREG
	incf	BUFREAD,f
	
	bcf		STATUS,Z			;Parsing del codice comando e salto al codice relativo
	sublw	RUN_ACQ
	btfsc	STATUS,Z
	goto	RunAcq
	movf	TEMPREG,w
	bcf		STATUS,Z
	sublw	STOP_ACQ
	btfsc	STATUS,Z
	goto	StopAcq
	movf	TEMPREG,w
	bcf		STATUS,Z
	sublw	WRITE_TO_MEM
	btfsc	STATUS,Z
	goto	WriteToMem
	movf	TEMPREG,w
	bcf		STATUS,Z
	sublw	READ_TO_MEM
	btfsc	STATUS,Z
	goto	ReadFromMem
	movf	TEMPREG,w
	bcf		STATUS,Z
	sublw	RESET
	btfsc	STATUS,Z
	goto	Reset
	movf	TEMPREG,w
	bcf		STATUS,Z
	sublw	BIT_WORD
	btfsc	STATUS,Z
	goto	BitSetWord
	movf	TEMPREG,w
	bcf		STATUS,Z
	sublw	RET_COUNT
	btfsc	STATUS,Z
	goto	ReturnCounters

	call	CommandError
	goto	Tnb

ReturnCounters
	bsf		FLAGREG,RETCOU		;Settaggio del flag di esecuzione dell'istruzione
	goto	EndCommand

ReturnCountersExec
	bcf		FLAGREG,RETCOU
	movlw	d'64'				;Inzializzazione di TEMPREG, che funziona da contatore, permettendo
	movwf	TEMPREG				;di scandire la memoria contatori (64 bytes)
	bsf		STATUS,IRP			;Inzializzazione del puntatore al vettore dei numeri random biased
	movlw	byte_biased
	movwf	FSR
Loop10
	movf	INDF,w				;In w si trova il byte che BinNumToASCII deve processare
	call	BinNumToASCII
	movf	CENTINAIA,w			;Trasmissione via seriale dei codici ASCII
	movwf	TXREG
	movf	DECINE,w
	call	TxWait
	movwf	TXREG
	movf	UNITA,w
	call	TxWait
	movwf	TXREG
	movlw	' '					;Spazio per separare un numero dal successivo
	call	TxWait
	movwf	TXREG
	incf	FSR,f
	decfsz	TEMPREG,f
	goto	Loop10
	bcf		STATUS,IRP
	goto	Tnb

RunAcq
	bsf		FLAGREG,STAACQ		;Settaggio del flag di esecuzione dell'istruzione
	goto	EndCommand

RunAcqExec
	bcf		FLAGREG,STAACQ
	call	BitsAcqInit
	clrf	TMR2				;Azzeramento timer2
	bsf		FLAGREG,STARTACQ	;Abilitazione della routine di acquisizione
	bsf		T2CON,TMR2ON		;Abilitazione timer acquisizione
	movf	BITWORD,w			;Inizilizzazione di BITCOUNT a BITWORD
	movwf	BITCOUNT
	goto	Tnb

StopAcq
	bsf		FLAGREG,STOACQ		;Settaggio del flag di esecuzione dell'istruzione
	goto	EndCommand

StopAcqExec
	bcf		FLAGREG,STOACQ
	bcf		T2CON,TMR2ON		;Disabilitazione timer acquisizione
	bcf		FLAGREG,STARTACQ	;Disabilitazione della routine di acquisizione
	goto	Tnb

WriteToMem
	call	WaitNewByte
	movf	BUFREAD,w			;Caricamento dell'indirizzo sorgente nel puntatore FSR
	addlw	Buffer_Location		;(Buffer_Location + BUFREAD)
	movwf	FSR
	movf	INDF,w
	movwf	DATMEM				;Recupero del byte e scrittura in DATMEM
	call	DatMemOk			;DatMemOk verifica che DATMEM sia un indirizzo valido nella memoria dati
	btfsc	STAPRO,ERR
	goto	Tnb
	incf	BUFREAD,1
	call	WaitNewByte
	movf	BUFREAD,w			;Caricamento dell'indirizzo sorgente nel puntatore FSR
	addlw	Buffer_Location		;(Buffer_Location + BUFREAD)
	movwf	FSR
	movf	INDF,w
	movwf	DML					;Recupero del byte e scrittura in DML del numero di bytes
	call	InMemory			;InMemory verifica che DATMEM e DML siano compatibili con la
	btfss	STAPRO,ERR			;memoria dati. Se ERR  alto, si  verificata una incompatibilit,
	goto	Jump13				;quindi viene generato un errore
	bcf		STAPRO,ERR
	goto	Tnb					
Jump13
	incf	BUFREAD,1
	bsf		STAPRO,WDATA
	goto	EndCommand
	
ReadFromMem
	call	WaitNewByte
	movf	BUFREAD,w			;Caricamento dell'indirizzo sorgente nel puntatore FSR
	addlw	Buffer_Location		;(Buffer_Location + BUFREAD)
	movwf	FSR
	movf	INDF,w
	movwf	DATMEM				;Recupero del byte e scrittura in DATMEM
	call	DatMemOk			;DatMemOk verifica che DATMEM sia un indirizzo valido nella memoria dati
	btfsc	STAPRO,ERR
	goto	Tnb
	incf	BUFREAD,1
	call	WaitNewByte
	movf	BUFREAD,w			;Caricamento dell'indirizzo sorgente nel puntatore FSR
	addlw	Buffer_Location		;(Buffer_Location + BUFREAD)
	movwf	FSR
	movf	INDF,w
	movwf	DML					;Recupero del byte e scrittura in DML del numero di bytes
	call	InMemory			;InMemory verifica che DATMEM e DML siano compatibili con la
	btfss	STAPRO,ERR			;memoria dati. Se ERR  alto, si  verificata una incompatibilit,
	goto	Jump14				;quindi viene generato un errore
	bcf		STAPRO,ERR
	goto	Tnb					
Jump14
	incf	BUFREAD,1
	bsf		STAPRO,RDATA
	goto	EndCommand

Reset
	bsf		FLAGREG,RST			;Settaggio del flag di esecuzione dell'istruzione
	goto	EndCommand

ResetExec
	call	TxWait				;Necessaria per evitare la perdita di eventuali bytes inviati
	clrf	T2CON				;Reset dei registri sensibili
	bsf		STATUS,RP0
	clrf	TXSTA
	clrf	PIE1
	bcf		STATUS,RP0
	clrf	PIR1
	clrf	RCSTA
	clrf	STATUS
	clrf	INTCON
	goto	Start				;Salto all'inizio del programma (reinizializzazione)

BitSetWord
	call	WaitNewByte
	movf	BUFREAD,w			;Caricamento dell'indirizzo sorgente nel puntatore FSR
	addlw	Buffer_Location		;(Buffer_Location + BUFREAD)
	movwf	FSR
	bcf		STATUS,Z
	movf	INDF,w				;Recupero del byte e scrittura in w
	movwf	BITWORD
	btfss	STATUS,Z			;Verifica di BITWORD!=0
	goto	Jump17
	call	SymbLenError
	goto	Tnb
Jump17
	bcf		STATUS,C			;Verifica di BITWORD<=5
	sublw	0x05
	btfsc	STATUS,C
	goto	Jump18
	call	SymbLenError
	goto	Tnb
Jump18
	incf	BUFREAD,1
	goto	EndCommand

EndCommand
	bsf		STAPRO,PARS
	goto	Tnb


ReadStopByte
	movf	BUFREAD,w			;Caricamento dell'indirizzo sorgente nel puntatore FSR
	addlw	Buffer_Location		;(Buffer_Location + BUFREAD)
	movwf	FSR
	movf	INDF,w
	bcf		STATUS,Z
	sublw	STOP_BYTE
	btfsc	STATUS,Z
	goto	Jump15
	call	StopByteError
	goto	Tnb
Jump15
	btfss	STAPRO,WDATA		;Se il byte di stop  di un comando di scambio dati, lo
	goto	Jump11				;stato del protocollo viene resettato senza la perdita
	call	ProDataReset		;dei dati sensibili inviati dal comando
	call	SendACK
	goto	Tnb
Jump11
	btfss	STAPRO,RDATA		;Se il byte di stop  di un comando di scambio dati, lo
	goto	Jump12				;stato del protocollo viene resettato senza la perdita
	call	ProDataReset		;dei dati sensibili inviati dal comando
	call	SendACK
	goto	ParsRData
Jump12
	call	ProAllReset			;Il protocollo viene resettato completamente
	call	SendACK
	goto	TnbExec

WriteStopByte
	movlw	STOP_BYTE
	call	TxWait
	movwf	TXREG
	call	ProAllReset
	goto	Tnb
	
;************************************************************************
;*																		*
;************************************************************************


;************************************************************************
;*	VETTORE DI INTERRUPT												*
;************************************************************************

IntVect
ContextSave
	movwf	W_TEMP				;Salvataggio di W
	swapf	STATUS,w
	movwf	STATUS_TEMP			;Salvataggio dello STATUS (con i nibbles swappati)
	clrf	STATUS 				;Reset dello STATUS (pagina 0)
	movf	PCLATH,w
	movwf	PCLATH_TEMP			;Salvataggio di PCLATCH
	clrf	PCLATH				;Reset di PCLATCH (pagina 0)
	movf	FSR,w
	movwf	FSR_TEMP			;Salvataggio di FSR

OriginControl					;Controllo origine interrupt
	btfsc	PIR1,RCIF			;USART
	goto	UsartReceive
	btfsc	PIR1,TMR2IF			;Timer2
	goto	Timer2Match
	goto	ContextRestore

Timer2Match
	bcf		INTCON,PEIE			;Disabilitazione gestione INT da tutte le periferiche

	movlw	Bit_Start
	bsf		STATUS,IRP
	movwf	FSR					;Inizializzazione di FSR alla memoria dati riservata ai bit

	btfss	PORTB,INRANDOM		;lettura dato e seguente set/reset
	goto	letto_0				;della locazione corrente di memoria dati
	bsf		INDF,0				;rb5= 1 --> setto  [INDF], 0 --> setto il bit 0 di Bit_Start

	movlw	bit_uno				;conto solo il numero di bit a '1' presenti nella sequenza
	movwf	FSR					;FSR punta a bit_uno
	incf	INDF, f
	
	Ptr		byte_biased, byteletti		;FSR punta al registro n dove andr a memorizzare l' n-esimo byte letto

	bsf		STATUS,C			;rb5= 1 --> setto  [INDF], 0
	rlf		INDF,f				;moltiplico per 2 il numero ottenuto e aggiungo 1: mi permette di convertire 8 bit in 1 byte
								;        C 76543210
								;RLF     0 10000000
								;RLF     1 00000000			
								;RLF     0 00000001
	goto	conta_bit

letto_0
	bcf		INDF,0				;rb5= 0 --> resetto  [INDF], 0 --> resetto il bit 0 di Bit_Start
	Ptr		byte_biased, byteletti		;FSR punta al registro n dove andr a memorizzare l' n-esimo byte letto	
	bcf		STATUS,C			;rb5= 0 --> resetto  [INDF], 0
	rlf		INDF,f				;moltiplico per 2 il numero ottenuto e aggiungo 0: mi permette di convertire 8 bit in 1 byte
								;        C 76543210
								;RLF     0 10000000
								;RLF     1 00000000			
								;RLF     0 00000001
conta_bit
	movlw	cnt_bit
	movwf	FSR					;FSR punta a cnt_bit

	incf 	INDF, f				;lo incremento: conto i bit letti
	btfss	INDF, 3				;se il 3 bit  settato vuol dire che ho letto 8 bit
								;non posso usare incfsz perch qui il salto  deciso dal valore di un singolo bit 
	goto	non_azzerare_bit

	clrf	INDF				;azzero il contatore di bit per prepararlo alla lettura di un nuovo byte

	movlw	byteletti
	movwf	FSR					;FSR punta a byteletti
	incf	INDF,f				;lo incremento in modo che i successivi byte siano scritti nel relativo registro	

non_azzerare_bit
	movlw	byteletti
	movwf	FSR					;FSR punta a byteletti
	btfss	INDF, 5				;se il 5 bit  settato vuol dire che ho letto 32 byte == 256 bit == 256 simboli dal generatore casuale
	goto	preparazione_uscita_INT

;----------controllo chi quadro------------------------
;chi^2 = (#1 - #0)^2 / (#1 + #0)
;la sequenza  valida se chi^2 <= 3,8 (alpha= 0.05)
;cio:
;|#1 - #0| <= sqrt((#1 + #0)*3,8)
;ma se sono qui (#1 + #0) = 256
;quindi	
;|#1 - #0| <= 31,19
;
;Le sequenze valide di 256 bit sono formate al massimo da
;112 uno e 144 zero ho #1 - #0 = -32 == liminte inferiore
;144 uno e 112 zero ho #1 - #0 =  32 == liminte superiore
;cio la sequenza  valida se il #1  compreso tra 112 e 144
	
	movlw	bit_uno				;contiene il numero di 1 nella sequenza
	movwf	FSR					;FSR punta a bit_uno

	movlw	d'144'				;controllo che sia minore di 144
	subwf	INDF, w				;w= INDF-w e pone C=0 se l' operazione causa un prestito
	btfsc	STATUS, C			;se |bit_uno| >= 144 va a troppi_1
	goto	troppi_1
	movlw	d'112'				;controllo che sia minore di 112
	subwf	INDF, w				;w= INDF-w e pone C=0 se l' operazione causa un prestito
	btfss	STATUS, C			;se |bit_uno| < 112 va a troppi_0
	goto	troppi_0
	goto	sequenza_valida
;----------controllo se ho troppi 0 oppure 1------------------------
troppi_1
	;gestione retroazione termica
	bcf		PORTB,FEEDBACK		;raffredo la resistenza per far aumentare gli '0'
	goto	fine_chiquadro

troppi_0
	;gestione retroazione termica
	bsf		PORTB,FEEDBACK		;scaldo la resistenza per far aumentare gli '1'
	goto	fine_chiquadro
;----------fine controllo se ho troppi 0 oppure 1-------------------

sequenza_valida 				;la sequenza letta  valida: la trasmetto
	bsf		PORTB,ISVALID		;Attivo flag per indicare che sto per iniziare la trasmissione di una seq valida
;----------depolarizzo la sequenza------------------------
	movlw	cnt_bit
	movwf	FSR					;FSR punta a cnt_bit che viene usato per sapere quanti bit unbiased ho scritto.
	clrf	INDF				;lo azzero

	movlw	bit_uno
	movwf	FSR					;FSR punta a bit_uno che viene usato per sapere quanti byte unbiased ho scritto
	clrf	INDF				;lo azzero

	movlw	byteletti
	movwf	FSR					;FSR punta a byteletti, lo uso come indice per scandire byte_biased che  il vettore dei 
								;numeri random biased che hanno passato il chi^2
	clrf	INDF				;all' inizio deve essere 0 

								;Per tutto questo avrei potuto usare altri registri ma cos da ingegnere evito
								;di utilizzare memoria (del pic!) inutilmente e complico la vita a chi in fututo dovr mettere
								;le mani in questo programma
analizza_byte
	movf	INDF, w
	addlw	byte_biased		
	movwf	FSR					;punta al registro n che contiene l' n-esimo byte random letto	
								;in un pseudolinguaggio equivale a byte_biased[byteletti]
	
;----------analizzo le 4 coppie di bit che formano il byte in esame------------------------
coppia_4
		Unbiased_coppia_4
coppia_3	
		Unbiased_coppia_3
coppia_2
		Unbiased_coppia_2
coppia_1
		Unbiased_coppia_1
;----------fine analizzo le 4 coppie di bit che formano il byte in esame------------------------

byte_successivo
	movlw	byteletti
	movwf	FSR					;FSR punta a byteletti
	incf	INDF, f				;lo incremeto in modo da leggere i byte nel relativi registri
	btfss	INDF, 5				;se il 5 bit  settato vuol dire che ho letto tutt i 32 byte
	goto	analizza_byte

;----------fine depolarizzazione------------------------
fine_depolarizzazione			;ora i bit sono depolarizzati con von neumann e li vado a trasmettere
	movlw	bit_uno
	movwf	FSR					;FSR punta a bit_uno che ORA contiene il numeri di byte unbiased ho scritto
	decf 	INDF, f				;scarto l' ultimo valore perch la probabilit che non sia completo (esempio ottengo 8*15+3 = 15 byte
								;unbiased + 3 bit)  elevata e fare il controllo per vedere se cnt_bit == 0 mi fa perdere troppo tempo

	;Questo  un ulteriore controllo (paranoico?):
	;per l' algo di depolarizzazione usato la lunghezza della sequenza dimezza
	;quindi se bit_uno  maggiore di 32/2 = 16 significa che si sono verificati problemi e allora non tasmetto nulla
	;va bene anche se la sequenza depolarizzata  formata da un solo byte che sia anche non completo
	;TODO: che succede se la sequenza depolarizzata  formata da un solo byte e arrivo qui con bit_uno=0?
	movlw	d'16'				;controllo che sia minore di 16
	subwf	INDF, w				;w = INDF-w e pone C=0 se l' operazione causa un prestito
	btfsc	STATUS, C			;C == 0 solo se bit_uno < 16
	goto	nulla_da_trasmettere

txsequenza:
	Ptr		byte_unbiased, bit_uno 	;ora ho FSR che punta al bit_uno registro dopo byte_unbiased
	movf	INDF, w
	movwf	TXREG				;trasmetto il byte della sequenza
	call	TxWait

	movlw	bit_uno
	movwf	FSR					;FSR punta a bit_uno
	decfsz	INDF				;decremento bit_uno per scandire tutto il vettore di byte unbiased
	goto	txsequenza			;trasmetto la sequenza a rovescio ma non importa, tanto i dati casuali sono scorrellati tra loro
	
	;TODO: che succede se la sequenza depolarizzata  formata da un solo byte? lo trasmetto 2 volte?
	movlw	byte_unbiased 		;tramsetto il primo bit della sequenza depolarizzata
	movwf	FSR					;FSR punta a byte_unbiased
	movf	INDF, w				;trasmetto il byte *(byte_unbiased+0)
	movwf	TXREG
	call	TxWait

nulla_da_trasmettere
	;SendValue 'LTK'			;istruzione inutile,  per questo che la commento; anche errata
	bcf		PORTB,ISVALID		;Disattivo flag perch ho finito di trasmettere la seq valida

fine_chiquadro
	movlw	cnt_bit 
	movwf	FSR					;FSR punta a cnt_bit 
	clrf	INDF				;se l' ultimo byte unbiased non  completo (esempio ottengo 8*15+3 = 15 byte unbiased + 3 bit)
								;ho cnt_bit != 0 
	incf	FSR					;FSR punta a byteletti
	clrf	INDF
	incf	FSR					;FSR punta a bit_uno: lo azzero perch cos  pronto per il suo ruolo abituale nell' acquisizione della nuova sequenza
	clrf	INDF
								;non serve azzerare i buffer dove memorizzo le sequenze perch i vari rlf eliminano uno per uno 
								;tutti i dati precedenti
;----------fine controllo chi quadro, depolarizzazione e trasmissione sequenza-------------------

preparazione_uscita_INT
	bsf		INTCON,PEIE			;Risabilitazione gestione INT da tutte le periferiche
	movlw	Bit_Start
	bsf		STATUS,IRP
	movwf	FSR					;Inizializzazione di FSR alla memoria dati riservata ai bits

	rlf		INDF,f				;Shift a sinistra della locazione puntata da INDF
	decf	BITCOUNT,f			;Decremento del contatore di bit acquisiti

	bcf		PIR1,TMR2IF			;Azzeramento del flag di INT del timer2
	goto	ContextRestore

UsartReceive
	movlw	06h					;Maschera
	andwf	RCSTA,w
	btfsc	STATUS,Z			;Controllo dei flag di errore FERR e OERR 
	goto	Jump20
	call	UsartError			;Errore di comunicazione seriale
	bcf		RCSTA,OERR			;Azzeramento del flag OERR
	goto	UsartEnd
Jump20
	btfss	STAPRO,BUSY			;Controllo del flag BUSY: se  1, il comando/dato corrente verr rifiutato
	goto	Jump2				;perch il PIC deve terminare l'elaborazione del comando/dato precedente
	call	BusyError			;e verr generato un errore
	goto	UsartEnd
Jump2
	movf	BUFLEN,w			;Caricamento dell'indirizzo di destinazione nel puntatore FSR
	addlw	Buffer_Location
	movwf	FSR
	movf	RCREG,w				;Spostamento del byte ricevuto dalla linea seriale in w
	movwf	INDF				;Scrittura del byte nel buffer

	btfss	STAPRO,BYTPAC		;Test di BYTPAC: proseguo se  stato processato il numero di bytes del
	goto	Jump0				;pacchetto corrente

	movlw	0x01				;Test di BUFLEN = (LENPAC-1): proseguo se la condizione  verificata
	subwf	LENPAC,w			;(se il pacchetto  lungo 100 bytes, BUFLEN va da 0 a 99)		
	bcf		STATUS,Z	
	subwf	BUFLEN,w
	btfss	STATUS,Z
	goto	Jump0
	movf	INDF,w				;Recupero del byte "presunto" di stop (in FSR  rimasto invariato l'indirizzo)
	bcf		STATUS,Z			;Test del byte corrente: se  un byte di stop valido viene settato il flag
	sublw	STOP_BYTE			;BUSY, diversamente viene generato un errore
	btfsc	STATUS,Z
	goto	Jump1
	call	StopByteError
	goto	UsartEnd
Jump1
	bsf		STAPRO,BUSY
Jump0
	incf	BUFLEN,1			;Incremento di BUFLEN
UsartEnd
	bcf		PIR1,RCIF			;Reset del flag di ricezione USART

ContextRestore
	movf	FSR_TEMP,w			;Ripristino dei registri sensibili
	movwf	FSR
	movf	PCLATH_TEMP,w 
	movwf	PCLATH
	swapf	STATUS_TEMP,w
	movwf	STATUS
	swapf	W_TEMP,f
	swapf	W_TEMP,w

	retfie

;************************************************************************
;*	SUBROUTINES															*
;************************************************************************
	#include <func.inc>
;************************************************************************

;************************************************************************
;*	fine main															*
;************************************************************************

	END